﻿using System.Collections.Generic;
using System.Drawing;
using NTERA.Core;
using NTERA.Engine.Compiler;
using NTERA.Engine.Runtime.Resources;

namespace NTERA.Engine.Runtime
{
	public interface IExecutionProvider
	{
		void Initialize(IConsole console);

		ICollection<FunctionDefinition> DefinedProcedures { get; }
		ICollection<FunctionDefinition> DefinedFunctions { get; }
		ICollection<FunctionVariable> DefinedConstants { get; }
		CSVDefinition CSVDefinition { get; }

		IEnumerable<ExecutionNode> GetExecutionNodes(FunctionDefinition function);

		Bitmap GetImage(string imageName, out ImageDefinition definition);
	}
}